#Linux version
#!/usr/bin/env python
import os, sys, shutil, zipfile

print 'This Python script will package your map in\na correct directory tree\nin your current directory.\nWhen the script is finished, you will have a zip file\nready to upload to Quadropolis\nHappy mapping!\n'

mapname = ''
basedir = ''
mapsdir = ''
localmapsdir = ''
mapext = ''
gamenames = {1:'Sauerbraten', 2:'Assault Cube', 3:'Cube', 4:'Blood Frontier SVN'}

game = input('What game/mod are you using? Type in the corresponding number.\n'
             '1. Sauerbraten\n'
             '2. Assault Cube\n'
             '3. Cube\n'
             '4. Blood Frontier SVN\n')

print 'It seems that you are using', gamenames[game]

mapname = raw_input('What is the name of the map you want to package?\n(Please omit any file extension) >')
print '\n'

if game == 1:
    mapsdir = os.path.join(basedir, 'packages', 'base')
    localmapsdir = os.path.join('packages', 'base')
    mapext = '.ogz'
elif game == 2:
    mapsdir = os.path.join(basedir, 'packages', 'maps')
    localmapsdir = os.path.join('packages', 'maps')
    mapext = '.cgz'
elif game == 3:
    mapsdir = os.path.join(basedir, 'packages', 'base')
    localmapsdir = os.path.join('packages', 'base')
    mapext = '.cgz'
elif game == 4:
    mapsdir = os.path.join(basedir, 'bfa', 'maps')
    localmapsdir = os.path.join('bfa', 'maps')
    mapext = '.bgz'
else:
    print 'Unknown game entered!'
    sys.exit(1)

os.makedirs(localmapsdir)

shutil.copy(os.path.join(mapsdir, mapname + mapext), localmapsdir)

if os.path.exists(os.path.join(mapsdir, mapname + '.cfg')):
    shutil.copy(os.path.join(mapsdir, mapname + '.cfg'), localmapsdir)
else:
    print 'No config file exists! It is a good idea to create one, as it lets you define a skybox, music, etc.\n'


if os.path.exists(os.path.join(mapsdir, mapname + '.jpg')):
    shutil.copy(os.path.join(mapsdir, mapname + '.jpg'), localmapsdir)
else:
    print 'No screenshot for your map exists! It will be displayed when the game loads your map,\nso good for first impressions.\n'

if os.path.exists(os.path.join(mapsdir, mapname + '.txt')):
    shutil.copy(os.path.join(mapsdir, mapname + '.txt'), localmapsdir)
else:
    print 'No readme file exists, or it is not named', mapname + '.txt. It is not required, but it is a nice touch.'


filelist = []

for file in os.listdir(localmapsdir):
    filelist.append(os.path.join(localmapsdir, file))

zfilename = mapname + '.zip'

finalzip = zipfile.ZipFile(zfilename, "w", zipfile.ZIP_DEFLATED)

for entry in filelist:
    finalzip.write(entry)
    os.remove(entry)

finalzip.close()

os.removedirs(localmapsdir)
print 'Success! There should be a file named ', zfilename, ' sitting in your directory, ready to be uploaded to Quadropolis!'